// IEPagerCtrl.cpp : implementation file
//

#include "stdafx.h"
#include "IEPager.h"
#include "IEPagerCtrl.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CIEPagerCtrl

CIEPagerCtrl::CIEPagerCtrl()
{
	m_bCreated = FALSE;
	bInit = FALSE;
}

CIEPagerCtrl::~CIEPagerCtrl()
{
}


BEGIN_MESSAGE_MAP(CIEPagerCtrl, CToolBar)
	//{{AFX_MSG_MAP(CIEPagerCtrl)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CIEPagerCtrl message handlers


/*
 * Function: SetSize
 * Argumments:
 *		int nCurrentSize - The Current Size of the main window
 * Return:
 *		void
 * Remarks:
 *		Use this funcion to notify the control,
 *		to make itself smaller or larger.
 */
void CIEPagerCtrl::SetSize(int nCurrentSize)
{
	//BUTTONSINFO structure, is create to contain the information
	//about the all buttons which are goin to be hidden, so they can be restored later
	//Cleaver isnt it;)
	BUTTONSINFO HiddenButtonsInfo;
	//Check if the toolbar control is created
	//because that function is called by the mainframe,
	//and is called by WM_SIZE Handler, so it is called before the toolbar ctrl is created,
	//and the functions inside that if, will throw assert and the program wont run!!!
	//The system is posting two WM_SIZE hendlers to the MainFrame so we got the function runned 2 times,
	//Which in the 1st time our toolbar isnt still created, so we pass the first time(see on the end of the function)
	if ( m_bCreated )
	{
		//nCount - Toolbar current buttons count...
		int nCount = GetToolBarCtrl ( ).GetButtonCount ( );
		//nSizeOfButton - size of a button(needed for our new button to be added)
		int nSizeOfButton = HIWORD ( GetToolBarCtrl ( ).GetButtonSize ( ) );
		//nToolBarSize - that is the whole toolbar(size of a button*buttons count)
		int nToolBarSize = nSizeOfButton*nCount;

		//Check if the toolbar is all variables are inited - see below ...
 		if ( bInit )
		{
			//Check if the current size of the main window is low then the FirstToolBarSize button.
			if ( nCurrentSize < nFirstToolBarSize )
			{
				// y - checker
				// nFCB = nFirstCoveredButton - the first button which is covered by the main window
				int y = 0, nFCB = 0;
				int ras = 0;
				//and now checking which is the number of the first covered button(and writing it into nFCB)
				for ( int i = 1; i < nAllButtons; i++ )
				{
					//
					y = i*nSizeOfButton;
					ras = nCurrentSize - y;
					if ( y > nCurrentSize )
					{
						nFCB = i;
						int nRemainButtons = nFCB - 1;
						int nSub = nRemainButtons*nSizeOfButton;
						int nRemainSpace = nCurrentSize - nSub;
						if ( nRemainSpace < nSizeOfButton )
							nFCB--;
						nGlFCB = nFCB;
						break;
					}
					else
					{
						if ( ras < nSizeOfButton )
						{
							nFCB = i;
							int nRemainButtons = nFCB - 1;
							int nSub = nRemainButtons*nSizeOfButton;
							int nRemainSpace = nCurrentSize - nSub;
							nFCB--;
							nGlFCB = nFCB;
							break;
						}
					}
				}
				//Now, before overwriting the information aobut the hidden buttons, we have
				//to save the information about the hidden buttons.
				//Now, set the number of the buttons to the count of the hidden buttons so we hide 'em;)
				SetButtons(NULL, nFCB + 1);
				for ( int counter = 0; counter < nFCB; counter++ )
				{
					SetButtonInfo ( counter, FirstButInfo[counter].nID,
						FirstButInfo[counter].nStyle, FirstButInfo[counter].iImage);
				}
				//Adding our new button with command id - ID_ARROW
				SetButtonInfo ( nFCB, ID_ARROW, TBBS_BUTTON, nAllButtons - 3);
			}
			//if the current size that we got from the OnSize function is more or equal on the
			//first toolbar size - set all the buttons back to normal state
			//that is made by that way - setting the buttons to nAllButtons which we got from the Initialization
			//and then with "for" we are setting their info which we got from the structure, filled
			//in the Initialization
			else
			{
				SetButtons(NULL, nAllButtons);
				for ( int counter = 0; counter < nAllButtons; counter++ )
				{
					SetButtonInfo ( counter, FirstButInfo[counter].nID,
						FirstButInfo[counter].nStyle, FirstButInfo[counter].iImage);
				}
			}
		}
		else
		{
			// The Initialization!!!
			//Getting the count of the Buttons and storing it in nAllButtons
			nAllButtons = GetToolBarCtrl ( ).GetButtonCount ( );
			//Getting the size of the whole toolbar ctrl(first size)
			nFirstToolBarSize = (HIWORD ( GetToolBarCtrl ( ).GetButtonSize ( ) ))*nAllButtons;
			//Filling the FirstButInfo with all the things we need to know 'bout first buttons
			for ( int counter = 0; counter < nAllButtons; counter++ )
			{
				//we are doing it with the GetButtonInfo (member of our base class)
				GetButtonInfo ( counter, FirstButInfo[counter].nID,
					FirstButInfo[counter].nStyle, FirstButInfo[counter].iImage);
				FirstButInfo[counter].strButtonText = GetButtonText ( counter );
			}
			//Adding our arrow bitmap to the image list
			GetToolBarCtrl ( ).AddBitmap ( 1, IDB_ARROW );
			//Init - done
			bInit = TRUE;
		}

	}
	m_bCreated = TRUE;
}

/*
 * Functuon: GetHiddenButtonsInfo
 * Arguments:
 *			BUTTONSINFO butInfo[100] structure, in which to be retrieved the information
 *		about only the hidden buttons.
 * Return:
 *		int, of Number of the buttons
 * Remarks:
 *			Use this function to retrieve the information, such as number of an image,
 *		ID and Style of the hidden buttons in the toolbar.
 */
int CIEPagerCtrl::GetHiddenButtonsInfo(BUTTONSINFO butInfo[100])
{

	//here we will place the tooltip string which we got from the StringTable.
	CString strTip;
	//here we will place the statusbar string which we got from the StringTable.
	CString strStatus;
	//Clean the buffered structure.
	for ( int i = 0; i < nAllButtons; i++)
	{
		butInfo[i].nID = 0;
		butInfo[i].nStyle = 0;
		butInfo[i].iImage = 0;
		butInfo[i].strButtonText = "";
		butInfo[i].strToolTip = "";
	}
	//now get the information about the hidden buttons, and write it tothe structure.
	for ( int count = nGlFCB, int y = 0; count < nAllButtons; count++, y++ )
	{
		butInfo[y].nID				= FirstButInfo[count].nID;
		butInfo[y].nStyle			= FirstButInfo[count].nStyle;
		butInfo[y].iImage			= FirstButInfo[count].iImage;
		strTip.LoadString ( FirstButInfo[count].nID );
		strTip = strTip.Right ( strTip.GetLength() - strTip.Find( "\n" ) - 1 );
		strStatus.LoadString ( FirstButInfo[count].nID );
		strStatus = strStatus.Left ( strStatus.Find( "\n" ) );
		butInfo[y].strToolTip		= strStatus;
		butInfo[y].strButtonText	= strTip;
	}
	return y;
}