// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "IEPager.h"

#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CSpawnFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CSpawnFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_WM_SIZE()
	ON_COMMAND(ID_ARROW, OnArrow)
	ON_WM_ACTIVATE()
	ON_WM_NCLBUTTONDOWN()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	cSpawn.LoadToolBarResource(IDR_MAINFRAME);
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CSpawnFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	// TODO: Delete these three lines if you don't want the toolbar to
	//  be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	GetSystemMenu(false);

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CSpawnFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CSpawnFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CSpawnFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers



//That Vars, removes a bug - when restored,
//from minimized state the toolbar isnt working;)
//shows only the fist button
int cx1 = 0,cy1 = 0;

void CMainFrame::OnSize(UINT nType, int cx, int cy) 
{
	if ( nType == SIZE_MINIMIZED )
	{
		cx1 = cx;cy1 = cy;		
	}
	else
	if ( nType == SIZE_RESTORED && cx1 != 0 && cy1 != 0)
	{
		m_wndToolBar.SetSize(cx1);
	}		

	m_wndToolBar.SetSize(cx);
//	m_wndToolBar.Invalidate();
	Invalidate();
	CSpawnFrameWnd::OnSize(nType, cx, cy);
}

void CMainFrame::OnArrow() 
{
	HMENU lMenu;
	CPoint pPoint;
	lMenu = ::CreatePopupMenu();
	if ( lMenu != NULL )
	{
		BUTTONSINFO butInfo[100];
		int nButtons = m_wndToolBar.GetHiddenButtonsInfo ( butInfo );
		for ( int i = 0; i < nButtons; i++ )
		{
			if ( butInfo[i].nStyle == TBSTYLE_SEP &&
				i == 0 ) {}
			else
				//Here you got two choices for what to be wroten in the menus -
				//First -
				//the status bar text associated with the toolbar button
				::AppendMenu(lMenu, MF_ENABLED | MF_STRING , butInfo[i].nID, butInfo[i].strToolTip );
				//Second -
				//the name of the toolbar(its tooltip text)
				//::AppendMenu(lMenu, MF_ENABLED | MF_STRING , butInfo[i].nID, butInfo[i].strButtonText );
		}
		CMenu *pMenu;
		pMenu = pMenu->FromHandle ( lMenu );
		CRect rect;	
		m_wndToolBar.GetToolBarCtrl().GetRect(ID_ARROW , &rect);
		m_wndToolBar.ClientToScreen(&rect);
		m_wndToolBar.GetToolBarCtrl().PressButton( ID_ARROW );
		pMenu->TrackPopupMenu ( TPM_LEFTBUTTON, rect.left, rect.bottom, this, NULL );
		m_wndToolBar.GetToolBarCtrl().PressButton( ID_ARROW, FALSE );
	}
	else
		TRACE0("ERROR: lMenu = NULL");
}



void CMainFrame::OnActivate(UINT nState, CWnd* pWndOther, BOOL bMinimized) 
{
	CSpawnFrameWnd::OnActivate(nState, pWndOther, bMinimized);
}

